"""
@author Vitaliy Bohera
@email vitaliyb@students.zcu.cz
@version 1
@task Zadani cislo 15 - Implementace znalostniho systemu pro pripravu vecere (pokrm Kung-pao)
@info Vysvetlovaci modul znalostniho systemu pro pripravu Kung-pao
@date 15.12.2023
"""
import time
import znalosti


'''
Funkce informuje uzivatele o pridani nahrady
@param nahrada - nahrada za surovinu
@param surovina - surovina pro kterou pridavame nahradu
'''
def vysvetli_pridani_nahrady(nahrada, surovina):
    pad_nahrada = znalosti.get_4pad_nahrady(nahrada)
    pad_surovina = znalosti.get_4pad_suroviny(surovina)
    print("Přidávám náhradu za {0} ...".format(pad_surovina))
    time.sleep(1)
    znalosti.pridej_nahradu(nahrada)
    print("{0} přidáno.".format(pad_nahrada.capitalize()))


'''
Funkce informuje uzivatele o pridani suroviny
@param surovna - surovina, kterou pridavame
'''
def vysvetli_pridani_suroviny(surovina):
    pad_surovina = znalosti.get_4pad_suroviny(surovina)
    print("Přidávám surovinu ...")
    time.sleep(1)
    znalosti.pridej_surovinu(surovina)
    print("{0} přidáno.".format(pad_surovina.capitalize()))


'''
Funkce vysvetli uzivateli nahradu za surovinu
@param surovina - surovina, pro kterou hledame nahradu
@return vrati nahradu pokud existuje, jinak vrati None
'''
def vysvetli_nahradu(surovina):
    nahrada = znalosti.zjisti_nahradu(surovina)
    pad_surovina = znalosti.get_4pad_suroviny(surovina)
    if nahrada == "":
        print("Pro {0} nejsou žádne náhradní suroviny.".format(pad_surovina))
        return None
    pad_nahrada = znalosti.get_7pad_nahrady(nahrada)
    print("{0} lze nahradit {1}.".format(pad_surovina.capitalize(), pad_nahrada))
    return nahrada


'''
Funkce vysvetli uzivateli ve kterem obchode muzeme koupit danou surovinu
@param surovina - surovina, kterou hledame v obchode
@return obchod - obcho, ve kterem muzeme koupit danou surovinu
'''
def vysvetli_obchod(surovina):
    pad_surovina = znalosti.get_4pad_suroviny(surovina)
    print("Jelikož nemáte {0}, přidávám surovinu k seznamu věcí, "
          "které potřebujete dokoupit v obchodě.".format(pad_surovina))
    print("Hledám {0} v obchodech ...".format(pad_surovina))
    time.sleep(3)
    obchod = znalosti.obchod_pro_surovinu(surovina)
    pad_obchod = znalosti.get_pad_obchod(obchod)
    print("{0} lze zakoupit v {1}.\n".format(pad_surovina.capitalize(), pad_obchod))
    return obchod


'''
Funkce vypise uzivateli zjistene informace:
    - suroviny, ktere ma uzivatel k dispozici
    - nahrady, ktere ma uzivatel k dispozici
    - seznamy surovin, ktere potrebuje uzivatel dokoupit v obchodech
'''
def vysvetli_obsah_uzivatele():
    print("Probíhá zpracování, prosím vyčkejte ...\n")
    time.sleep(5)
    vysvetli_obsah_lednicky()
    vysvetli_obsah_nahrad()
    vysvetli_nakupy_v_obchodech()


'''
Funkce vypise uzivateli vsechny suroviny ktere ma k dispozici
'''
def vysvetli_obsah_lednicky():
    suroviny = znalosti.get_suroviny_uzivatele()
    if len(suroviny) == 0:
        return
    print("Podle zjištěných informací máte k dispozici: ")
    for surovina in suroviny:
        pad_surovina = znalosti.get_4pad_suroviny(surovina)
        print("\t- {0}".format(pad_surovina))
    print()


'''
Funkce vypise uzivateli vsechny nahrady ktere ma k dispozici
'''
def vysvetli_obsah_nahrad():
    nahrady = znalosti.get_nahrady_uzivatele()
    if len(nahrady) == 0:
        return
    print("Suroviny, které nemáte ale můžete je nahradit: ")
    for nahrada in nahrady:
        surovina = znalosti.get_surovinu_podle_nahrady(nahrada)
        print("\t{0} -> {1}".format(surovina, nahrada))
    print()


'''
Funkce vypise uzivateli seznamy surovin, ktere potrebuje dokoupit v jednotlivych obchodech
v pripade, ze seznamy jsou prazdne, funkce nevypise nic
'''
def vysvetli_nakupy_v_obchodech():
    seznamy_nakupu = znalosti.get_dokoupit_v_obchode()
    neco_v_seznamu = False
    for key, value in seznamy_nakupu.items():
        if len(value) != 0:
            neco_v_seznamu = True
    if not neco_v_seznamu:
        return
    print("Seznamy surovin, které potřebujete dokoupit v jednotlivých obchodech: ")
    for key, value in seznamy_nakupu.items():
        if len(value) == 0:
            continue
        print("\t{0}: {1}".format(key, ", ".join(value)))
    print()
