"""
@author Vitaliy Bohera
@email vitaliyb@students.zcu.cz
@version 1
@task Zadani cislo 15 - Implementace znalostniho systemu pro pripravu vecere (pokrm Kung-pao)
@info Baze znalosti systemu pro pripravu Kung-pao
@date 15.12.2023
"""
import data


'''
Funkce pro zjisteni obchodu, ve kterem muzeme danou surovinu koupit
@param surovina - surovina, kterou hledame v obchodech
@return key - obchod, ve kterem muzeme danou surovinu koupit
'''
def obchod_pro_surovinu(surovina):
    for key, value in data.suroviny_v_obchodech.items():
        if surovina in value:
            return key


'''
Funkce pro zjisteni nahrady za danou surovinu
@param surovina - surovina, pro kterou hledame nahradu
@return value - nahrada nebo prazdny retezec pokud pro danou surovinu nemame zadnou nahradu
'''
def zjisti_nahradu(surovina):
    for key, value in data.nahrady.items():
        if key == surovina:
            return value


'''
Funkce prida surovinu k seznamu surovin, ktere ma uzivatel k dispozici
@param surovina - surovina, kterou ma uzivatel k dispozici
'''
def pridej_surovinu(surovina):
    data.suroviny_uzivatele.append(surovina)


'''
Funkce prida nahradu k seznamu nahrad, ktere ma uzivatel k dispozici
@param nahrada - nahrada, kterou ma uzivatel k dispozici
'''
def pridej_nahradu(nahrada):
    data.nahrady_uzivatele.append(nahrada)


'''
Funkce prida surovinu k seznamu veci, ktere uzivatel potrebuje dokoupit v danem obchode
@param surovina - surovina, kterou uzivatel potrebuje dokoupit
@param obchod - obchod, kde je dana surovina k dispozici
'''
def pridej_surovinu_z_obchodu(surovina, obchod):
    for key, value in data.dokoupit_v_obchode.items():
        if key == obchod:
            value.append(surovina)


'''
Funkce zjisti k jake surovine patri dana nahrada
@param nahrada - nahrada, pro kterou chceme zjistit, ke ktere surovine patri
'''
def get_surovinu_podle_nahrady(nahrada):
    for key, value in data.nahrady.items():
        if value == nahrada:
            return key


'''
Funkce vrati vsechny potrebne suroviny pro pripravu Kung-pao
@return seznam vsech surovin pro pripravu Kung-pao
'''
def get_suroviny():
    return data.suroviny


'''
Funkce vrati seznam surovin ktere ma uzivatel k dispozici
@return seznam surovin ktere ma uzivatel k dispozici
'''
def get_suroviny_uzivatele():
    return data.suroviny_uzivatele


'''
Funkce vrati seznam nahrad ktere ma uzivatel k dispozici
@return seznam nahrad ktere ma uzivatel k dispozici
'''
def get_nahrady_uzivatele():
    return data.nahrady_uzivatele


'''
Funkce vrati nakupni seznamy surovin pro jednotlive obchody
@return nakupni seznamy surovin, ktere potrebuje uzivatel dokoupit
'''
def get_dokoupit_v_obchode():
    return data.dokoupit_v_obchode


'''
Funkce zjisti 6.pad pro nazev obchodu
@param obchod - nazev obchodu
@return value - 6.pad nazvu obchodu
'''
def get_pad_obchod(obchod):
    for key, value in data.obchody_pad.items():
        if key == obchod:
            return value


'''
Funkce zjisti 4.pad suroviny
@param surovina - surovina, pro kterou chceme zjistit 4.pad
@return value - 4.pad suroviny
'''
def get_4pad_suroviny(surovina):
    for key, value in data.suroviny_4pad.items():
        if key == surovina:
            return value


'''
Funkce zjisti 7.pad nahrady
@param nahrada - nahrada, pro kterou chceme zjistit 7.pad
@return value - 7.pad nahrady
'''
def get_7pad_nahrady(nahrada):
    for key, value in data.nahrady_7pad.items():
        if key == nahrada:
            return value


'''
Funkce zjisti 4.pad nahrady
@param nahrada - nahrada, pro kterou chceme zjistit 4.pad
@return value - 4.pad nahrady
'''
def get_4pad_nahrady(nahrada):
    for key, value in data.nahrady_4pad.items():
        if key == nahrada:
            return value
