"""
Inferencni modul systemu. Ridi program.
Semestralni prace Lloydova 15
autor: Miroslav Martinek
e-mail: mira2002@students.zcu.cz
datum: 20.2.2023
verze: 2
"""
from baze_znalosti import *
from vysvetlovaci_modul import *
from komunikacni_modul import *


# urcuje tok programu vzhledem na uzivatelky vstup
def start():
    intro()
    cont = True
    # provadime dokud uzivatel chce pokracovat
    while(cont):
        info = parameter_input()  # ziskani rozmeru hlavolamu(N) a jak bude vytvoren pocatecni stav
        field = None
        if(not info[1]):  # uzivatel chce pocatecni stav manualne zadat
            field = field_input(info[0])

        root = prepare_root(field, info[0])
        start_state_message()
        print_field(root.field, info[0])  # koren vypiseme pred hledanim reseni, aby bylo na co se koukat

        solution = lloyds_n(root, info[0])  # hleda se reseni
        if(solution is None):  # reseni neexistuje
            unsolvable()
        else:  # nalezene reseni je prezentovano uzivateli
            solution_message()
            # kroky reseni zorganizujeme
            steps = [solution]
            while (steps[-1].parent != None):
                steps.append(steps[-1].parent)
            steps.reverse()
            # vysvetleni reseni(vypis kroku)
            counter = 0
            for step in steps:
                print_step_number(counter)
                print_field(step.field, info[0])
                counter += 1
        cont = continue_input()  # ziskame zda uzivatel chce pokracovat

