"""
Vysvetlovaci modul systemu. Dynamicka a interaktivni komunikace.
Script spoustici program.
Semestralni prace Lloydova 15
autor: Miroslav Martinek
e-mail: mira2002@students.zcu.cz
datum: 20.2.2023
verze: 2
"""


# vstup parametru pocatecniho stavu
# vraci list [N(int), nahoda(True)/manual(False)
def parameter_input():
    info = []
    n = input("Zadejte velikost(cele kladne cislo) hraciho pole N.\n")
    while(not n.isnumeric()):
        n = input("Zadejte velikost(cele kladne cislo) hraciho pole N.\n")
    info.append(int(n))

    mode = input("Pro nahodny pocatecni stav zadejte 'n'. Pro manualne zadany pocatecni stav zadejte 'm'.\n")
    while(mode != "n" and mode != "m"):
        mode = input("Pro nahodny pocatecni stav zadejte 'n'. Pro manualne zadany pocatecni stav zadejte 'm'.\n")
    info.append(mode == "n")
    return info


# manualni vstup pocatecniho stavu
# vraci list [reprezentace herniho pole(2d list), x souradnice volneho mista(int), y souradnice volneho mista(int)]
def field_input(n):
    x = 0
    y = 0
    field = []
    used_nums = [0]*(n*n)
    for row in range(n):
        field.append([])
        for column in range(n):
            input_val = input("Zadejte hodnotu('X' pro volne misto) pro kamen v " + str(column + 1) +
                              ". sloupci " + str(row + 1) + ". radce:")
            if(input_val == "X"):
                input_val = str(n*n)  # cilo n*n reprezentuje volne pole pri hledani reseni
                x = column
                y = row

            # oprava vstupu
            while(not input_val.isnumeric() or int(input_val) > n*n or used_nums[int(input_val) - 1] != 0):
                input_val = input("Nespravny vstup!\nZadejte hodnotu('X' pro volne misto) pro kamen v " + str(column + 1) +
                                  ". sloupci " + str(row + 1) + ". radce:")
                if (input_val == "X"):
                    input_val = str(n*n)  # cilo n*n reprezentuje volne pole pri hledani reseni
                    x = column
                    y = row
            field[row].append(int(input_val))
            used_nums[int(input_val) - 1] = 1

    field_info = [field, x, y]
    return field_info


# vstup zda uzivatel chce pokracovat
# vraci ano(True)/ne(False)
def continue_input():
    return input("Pokud chcete pokracovat zadejte 'ano'.\n") == "ano"


# dynamicky vypis herniho stavu
def print_field(field, n):
    form = "{:<5}"  # cila zarovnavame na 5 znaku
    print("-" * (n * 5 + 2))
    for row in range(n):
        line = "|"
        for column in range(n):
            if(field[row][column] == n*n):
                line += form.format("X")  # pro uzivatele X reprezentuje volne misto
            else:
                line += form.format(str(field[row][column]))
        line += "|"
        print(line)
    print("-" * (n * 5 + 2))


# vypis cisla kroku
def print_step_number(step_number):
    print("Krok cislo " + str(step_number))
