"""
Description: Tento modul ukládá a poskytuje znalosti.
Author: Václav Ovsík
E-mail: ovsikv@students.zcu.cz
Version: 1.0
Date: 18.12.2023
"""


def can_take_from_one(count, row_index, board):
    """
    Pravidlo pro odebírání zápalek z jedné hromádky.
    :param count: počet zápalek k odebrání
    :param row_index: čislo hromádky
    :param board: seznam počtů zápalek v každé hromádce
    :return: True pokud lze odebrat určený počet zápalek
             False pokud nelze odebrat určený počet zápalek
    """
    if board[row_index] < count:
        return False
    return True


def can_take_from_two(count, row_index_1, row_index_2, board):
    """
    Pravidlo pro odebírání zápalek ze dvou hromádek.
    :param count: počet zápalek k odebrání z obou hromádek
    :param row_index_1: čislo první hromádky
    :param row_index_2: čislo druhé hromádky
    :param board: seznam počtů zápalek v každé hromádce
    :return: True pokud lze odebrat určený počet zápalek z obou hromádek
             False pokud nelze odebrat určený počet zápalek z obou hromádek
    """
    if board[row_index_1] < count or board[row_index_2] < count:
        return False
    return True
