# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 17. 12. 2023
# Verze: 1.0
# Semestralni prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Modul baze_dat slouzi k ukladani dat - prvku vyrazu, jako jsou operatory, konstanty nebo promenne.
# Promenne jsou nicmene pridavany az za behu, jelikoz dopredu neni jasne, jak se budou jmenovat.
# ------------------------------------------------------------------------------------------------


# Trida definuje prvek vyrazu - konstantu, promennou, nebo operator.
class PrvekVyrazu:
    def __init__(self, typ, reprezentace):
        self.typ = typ
        self.reprezentace = reprezentace

    # Porovnani s jinymi objekty. Je nutne definovat z toho duvodu,
    # aby bylo mozne jednoduse porovnavat ekvivalenci prvku vyrazu.
    def __eq__(self, obj):
        if isinstance(obj, PrvekVyrazu):
            return self.reprezentace == obj.reprezentace and self.typ == obj.typ
        return False


TRUE = PrvekVyrazu("konstanta", "true")
FALSE = PrvekVyrazu("konstanta", "false")
AND = PrvekVyrazu("binarni operator", "and")
OR = PrvekVyrazu("binarni operator", "or")
NOT = PrvekVyrazu("unarni operator", "not")
XOR = PrvekVyrazu("binarni operator", "xor")
IMPL = PrvekVyrazu("binarni operator", "impl")
EQUIV = PrvekVyrazu("binarni operator", "equiv")
# K promenne zatim nevime, co bychom priradili za oznaceni.
PROMENNA = PrvekVyrazu("promenna", None)


PREDDEFINOVANE_PRVKY = [TRUE, FALSE, AND, OR, NOT, XOR, IMPL, EQUIV]

# uzivatelem definovane promenne ve vyrazu
promenne = {}
