# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 17. 12. 2023
# Verze: 1.0
# Semestralni prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Tento modul uchovava prepisovaci pravidla, diky kterym je mozne vyraz zjednodusit.
# V inferencnim modulu se pak za promenne dosadi konstanty TRUE a FALSE, a po aplikaci
# posledniho prepisovaciho pravidla z vyrazu zustane pouze konstanta (TRUE nebo FALSE).
# ------------------------------------------------------------------------------------------------

from baze_dat import *


class PrepisujeSeNa:
    def __init__(self, puvodni_vyraz, prepsany_vyraz):
        self.puvodni_vyraz = puvodni_vyraz
        self.prepsany_vyraz = prepsany_vyraz


# Promennou je minena jedna a ta sama promenna, nikoliv libovolna.
prepisovaci_pravidla = [
    PrepisujeSeNa([TRUE, AND, TRUE], [TRUE]),
    PrepisujeSeNa([TRUE, OR, TRUE], [TRUE]),
    PrepisujeSeNa([TRUE, OR, FALSE], [TRUE]),
    PrepisujeSeNa([TRUE, AND, FALSE], [FALSE]),
    PrepisujeSeNa([TRUE, OR, PROMENNA], [TRUE]),
    PrepisujeSeNa([FALSE, OR, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([TRUE, AND, NOT], [NOT]),
    PrepisujeSeNa([FALSE, OR, NOT], [NOT]),
    PrepisujeSeNa([TRUE, AND, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([FALSE, OR, FALSE], [FALSE]),
    PrepisujeSeNa([FALSE, AND, FALSE], [FALSE]),
    PrepisujeSeNa([FALSE, OR, TRUE], [TRUE]),
    PrepisujeSeNa([FALSE, AND, TRUE], [FALSE]),
    PrepisujeSeNa([FALSE, OR, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([FALSE, AND, PROMENNA], [FALSE]),
    PrepisujeSeNa([NOT, FALSE], [TRUE]),
    PrepisujeSeNa([NOT, TRUE], [FALSE]),
    PrepisujeSeNa([PROMENNA, OR, FALSE], [PROMENNA]),
    PrepisujeSeNa([PROMENNA, AND, FALSE], [PROMENNA]),
    PrepisujeSeNa([PROMENNA, AND, TRUE], [PROMENNA]),
    PrepisujeSeNa([PROMENNA, OR, TRUE], [TRUE]),
    PrepisujeSeNa([PROMENNA, OR, NOT, PROMENNA], [TRUE]),
    PrepisujeSeNa([PROMENNA, OR, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([PROMENNA, AND, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([PROMENNA, XOR, NOT, PROMENNA], [TRUE]),
    PrepisujeSeNa([PROMENNA, EQUIV, PROMENNA], [TRUE]),
    PrepisujeSeNa([PROMENNA, NOT, EQUIV, PROMENNA], [FALSE]),
    PrepisujeSeNa([PROMENNA, EQUIV, TRUE], [PROMENNA]),
    PrepisujeSeNa([TRUE, EQUIV, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([PROMENNA, EQUIV, FALSE], [NOT, PROMENNA]),
    PrepisujeSeNa([FALSE, EQUIV, PROMENNA], [NOT, PROMENNA]),
    PrepisujeSeNa([NOT, EQUIV, TRUE], [EQUIV, FALSE]),
    PrepisujeSeNa([NOT, EQUIV, FALSE], [EQUIV, TRUE]),
    PrepisujeSeNa([TRUE, XOR, TRUE], [FALSE]),
    PrepisujeSeNa([TRUE, XOR, FALSE], [TRUE]),
    PrepisujeSeNa([FALSE, XOR, TRUE], [TRUE]),
    PrepisujeSeNa([FALSE, XOR, FALSE], [FALSE]),
    PrepisujeSeNa([PROMENNA, XOR, TRUE], [NOT, PROMENNA]),
    PrepisujeSeNa([TRUE, XOR, PROMENNA], [NOT, PROMENNA]),
    PrepisujeSeNa([PROMENNA, XOR, FALSE], [PROMENNA]),
    PrepisujeSeNa([FALSE, XOR, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([PROMENNA, IMPL, TRUE], [TRUE]),
    PrepisujeSeNa([PROMENNA, IMPL, FALSE], [NOT, PROMENNA]),
    PrepisujeSeNa([TRUE, EQUIV, TRUE], [TRUE]),
    PrepisujeSeNa([TRUE, EQUIV, FALSE], [FALSE]),
    PrepisujeSeNa([FALSE, EQUIV, TRUE], [FALSE]),
    PrepisujeSeNa([FALSE, EQUIV, FALSE], [TRUE]),
    PrepisujeSeNa([PROMENNA, IMPL, PROMENNA], [TRUE]),
    PrepisujeSeNa([PROMENNA, IMPL, NOT, PROMENNA], [NOT, PROMENNA]),
    PrepisujeSeNa([TRUE, IMPL, TRUE], [TRUE]),
    PrepisujeSeNa([TRUE, IMPL, FALSE], [FALSE]),
    PrepisujeSeNa([FALSE, IMPL, TRUE], [TRUE]),
    PrepisujeSeNa([FALSE, IMPL, FALSE], [TRUE]),
    PrepisujeSeNa([TRUE, IMPL, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([FALSE, IMPL, PROMENNA], [TRUE]),
    PrepisujeSeNa([NOT, NOT, PROMENNA], [PROMENNA]),
    PrepisujeSeNa([PROMENNA, AND, NOT, PROMENNA], [FALSE]),
    PrepisujeSeNa([NOT, PROMENNA, AND, PROMENNA], [FALSE])
]
