# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 17. 12. 2023
# Verze: 1.0
# Semestralni prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# komunikacni_modul slouzi k vypisovani jednoduchych zprav na standardni vystup,
# nacitani dat ze souboru a zprostredkovava komunikaci inferencniho a vysvetlovaciho modulu.
# ------------------------------------------------------------------------------------------------
import vysvetlovaci_modul


# Zepta se uzivatele, co si preje vykonat.
def zeptej_se_na_vyraz():
    print("Zadejte prikaz k vykonani. Moznosti:")
    print("vysledek <vyraz>\tzobrazi podminky pro splnitelnost vyrazu")
    print("nacist <soubor> \tnacita postupne vyrazy ze souboru a zobrazi ke kazdemu vysledek")
    print("napoveda\t\tzobrazi napovedu")
    print("konec\t\t\tukonci program")
    print("------------------------------------------")
    return input("Vas vstup: ")


# Resi nespravny vstup.
def spatny_vstup():
    print("Nespravny vstup. Zkuste to prosim znovu.")


# Informuje o tom, ze ve vyrazu byla nalezena chyba a neni mozne jej vyhodnotit.
def nespravny_vyraz():
    print("Zadany vyraz neni validni. Zkuste to prosim znovu, popripade se podivejte na napovedu.")


# Informuje o IO chybe vznikle pri cteni/otevirani souboru.
def souborova_chyba():
    print("Chyba pri otevirani/cteni souboru.")


# Zobrazi prehlednou napovedu.
def zobraz_napovedu():
    print("Napoveda pro jednotlive prikazy:")
    print("Prikaz \"vysledek <vyraz>\"")
    print("\tZobrazi vsechna ohodnoceni logicke formule, pro ktere je splnitelna.")
    print("\tNejdrive je provadeno zjednoduseni logicke formule, ktere muze mimo jine vest k redukci promennych.")
    print("\tNasledne se provede vyhodnoceni, za jakych podminek je zjednodusena formule splnitelna.")
    print("\tPriklady pouziti:")
    print("\t\tvysledek (x and not x) or y")
    print("\t\tvysledek (true and false) and promenna")
    print("Prikaz \"nacist <soubor>\"")
    print("\tNacita postupne logicke vyrazy ze souboru, kde kazdy radek souboru reprezentuje jeden vyraz.")
    print("\tPo kazdem vyhodnocenem vyrazu zobrazi jeho vysledek a pocka")
    print("\tna pokyn uzivatele pro vyhodnoceni dalsiho vyrazu.")
    print("\tPro dalsi informace o vyhodnoceni vyrazu se podivejte na napovedu u prikazu \"vysledek\".")
    print("\tPriklady pouziti:")
    print("\t\tnacist vstup.txt")
    print("\t\tnacist vyrazy.txt")
    print("Prikaz \"napoveda\"")
    print("\tZobrazi tuto napovedu.")
    print("Prikaz \"konec\"")
    print("\tJakmile potvrdite klavesou ENTER, ukonci program.")
    print("------------------------------------------")


# Vypise informaci o tom, ze je nacitan urcity vyraz.
def vypis_vyraz(vyraz):
    print("Nacitam vyraz \"{}\"".format(vyraz))


# Ceka, nez si uzivatel prohlidne vysledek nacteneho vyrazu ze souboru
# a potvrdi dalsi pokracovani pomoci klavesy Enter.
def pokracuj_po_enteru():
    input("Pokracujte stisknutim klavesy ENTER.")
    print("------------------------------------------")


# Necha vysvetlovaci modul vysvetlit vysledek, ke kteremu dosel inferencni modul.
def vysvetlit_vysledek(zjednoduseni, vysledek, zjednoduseno, promenne):
    vysvetlovaci_modul.vysvetli_vysledek(zjednoduseni, vysledek, zjednoduseno, promenne)


# Otevre soubor a vrati seznam,
# ve kterem kazda polozka reprezentuje obsah jednoho radku.
def ziskej_radky_souboru(nazev_souboru):
    soubor = open(nazev_souboru, 'r')
    radky = soubor.readlines()
    # je nutne z radek odstranit bile znaky jako CR, LF
    radky = [radka.rstrip() for radka in radky]
    return radky
