# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 17. 12. 2023
# Verze: 1.0
# Semestralni prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Tento modul vysvetluje vysledky, ke kterym dosel inferencni modul.
# Tyto vysledky jsou jen tezko lidsky citelne, cilem vysvetlovaciho modulu
# je prevest je do pravdivostni tabulky, pripadne stanovit, ze vyraz
# je vzdy pravdivy / je vzdy nepravdivy.
# ------------------------------------------------------------------------------------------------

# Prevede zanorene vyrazy na retezec, ktery je citelny.
# To muze slouzit k vypisu mezivysledku, na ktery byla formule zjednodusena.
def ziskej_retezec_ze_zanoreneho_seznamu_atomu(seznam):
    k_vraceni = ""
    if not isinstance(seznam, list):
        # seznam ve skutecnosti neni seznamem, ale prvkem
        k_vraceni += seznam.reprezentace
        return k_vraceni
    for prvek in seznam:
        if isinstance(prvek, list):
            # rekurzivne ziskame retezec z podseznamu
            k_vraceni += "(" + ziskej_retezec_ze_zanoreneho_seznamu_atomu(prvek) + ") "
        else:
            # pridame prvek seznamu do retezce
            k_vraceni += prvek.reprezentace + " "

    # vratime k_vraceni bez posledniho prvku (tim je mezera)
    return k_vraceni[0:-1]


# Jako parametr prevezme ohodnoceni prvnich nekolika promennych
# a vypise vsechny vysledky, pokud na ohodnoceni zbytku promennych nezalezi.
def vypis_vsechny_varianty(seznam_hodnot, pocet_nezavislych_promennych):
    if pocet_nezavislych_promennych == 0:
        retezec = ""
        # vypiseme drive ohodnocene promenne
        for hodnota in seznam_hodnot:
            retezec += str(hodnota) + "\t"
        print(retezec)
        return
    elif pocet_nezavislych_promennych == 1:
        retezec = ""
        # opet vypiseme drive ohodnocene promenne, pak False
        # a take drive ohodnocene promenne a pak True
        for hodnota in seznam_hodnot:
            retezec += str(hodnota) + "\t"
        print(retezec + str(False))
        print(retezec + str(True))
        return
    # pridame do seznamu True/False a nechame rekurzivne vypsat vsechny varianty
    vypis_vsechny_varianty(seznam_hodnot + [False], pocet_nezavislych_promennych - 1)
    vypis_vsechny_varianty(seznam_hodnot + [True], pocet_nezavislych_promennych - 1)


# Vypise telo pravdivostni tabulky v zavislosti na dosazenem vysledku.
def vypis_promenne(seznam_hodnot, promenne, vysledek):
    if len(seznam_hodnot) < len(list(promenne)) and vysledek[0] != list(promenne)[len(seznam_hodnot)].reprezentace:
        # vysledek na promenne nezavisi, byla eliminovana (muze byt true nebo false)
        vypis_promenne(seznam_hodnot + [False], promenne, vysledek)
        vypis_promenne(seznam_hodnot + [True], promenne, vysledek)
        return
    if isinstance(vysledek[1], list):
        # na indexu 1 je seznam prave tehdy, pokud promenna muze byt false, ale jen v zavislosti na ohodnoceni
        # jinych promennych (tzn. to, ze je promenna false, neni dostacujici podminkou pro splnitelnost vyrazu)
        seznam = seznam_hodnot + [False]
        vypis_promenne(seznam, promenne, vysledek[1])
    elif vysledek[1]:
        # je mozne, ze na dalsich promennych vysledek nezavisi,
        # proto bychom meli vypsat vsechny varianty techto promennych, pokud tomu tak je
        if len(promenne) - len(seznam_hodnot) == 0:
            vypis_vsechny_varianty(seznam_hodnot, 0)
        else:
            vypis_vsechny_varianty(seznam_hodnot + [False], len(promenne) - 1 - len(seznam_hodnot))
    # nyni musime stejne operace provest pro true ohodnoceni promenne
    if isinstance(vysledek[2], list):
        seznam = seznam_hodnot + [True]
        vypis_promenne(seznam, promenne, vysledek[2])
    elif vysledek[2] and len(promenne) - len(seznam_hodnot) != 0:
        vypis_vsechny_varianty(seznam_hodnot + [True], len(promenne) - 1 - len(seznam_hodnot))


# Vysvetli vysledek, ke kteremu dospel inferencni modul.
def vysvetli_vysledek(zjednoduseni, vysledek, zjednoduseno, promenne):
    # vysledek je napr. ve tvaru ['x', ['z', True, False], ['y', ['z', True, False], ['z', False, True]]];
    # pro kazdou promennou je vysledek ve tvaru
    # [promenna, vysledek_pokud je ohodnocena false, vysledek pokud je ohodnocena true];
    # pokud jsou promenne ulozeny v poradi x, y, z, znamena to:
    # pokud je x nahrazeno za false, tak plati ['z', True, False], takze vysledek neni zavisly na y, ale musi
    # byt promenna z false (na 1. indexu v ['z', True, False) je True),
    # zatimco false byt nesmi (na 2. indexu, ktery reprezentuje false je False)
    # obdobne se pracuje s celym vyrazem (viz prilozena dokumentace)
    if not zjednoduseno:
        print("Vas vyraz se podle nadefinovanych pravidel nepodarilo zjednodusit a byl rovnou spusten algoritmus"
              " vyhodnoceni splnitelnosti logickych formuli s timto vysledkem:")
    else:
        print("Vas vyraz byl zjednodusen na formuli \"{}\" a nasledne byl spusten algoritmus"
              " vyhodnoceni splnitelnosti logickych formuli s timto vysledkem:"
              .format(ziskej_retezec_ze_zanoreneho_seznamu_atomu(zjednoduseni)))
    if not isinstance(vysledek, list):
        # vysledek je True nebo False
        print(vysledek)
    else:
        # musime vypsat pravdivostni tabulku
        retezec = ""
        # vypis hlavicky tabulky
        for promenna in promenne:
            retezec += promenna.reprezentace + "\t"
        print(retezec)
        print("------------------------------------------")
        # vypis tela tabulky
        vypis_promenne([], promenne, vysledek)
        print("------------------------------------------")
