"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-12-05
Program: Baze znalosti
Verze: 1.0.0
"""

# baze dat
import baze_dat as bd


# vytvori ctverec
def vytvor_ctverec(velikost):
    ctverec = []
    if velikost % 2 == 1:
        # radek
        for i in range(velikost):
            # sloupec
            for j in range(1, velikost + 1):
                # jedna "dvojice" ctverce
                # str((1 * (i - 1) + (j - 1)) % velikost)
                cast = [str((1 * (i - 1) + (j - 1)) % velikost), str((2 * (i - 1) + (j - 1)) % velikost)]
                # 0 prepsana na velikost ctverce
                if cast[1] == "0":
                    cast[1] = str(velikost)
                # 0 prepsana na velikost ctverce
                if cast[0] == "0":
                    cast[0] = str(velikost)
                # prida "dvojici"
                ctverec.append(cast)
    else:
        ctverec = bd.sude[str(velikost)][1]
    return ctverec


# kontroluje velikost (True = chyba, False = spravne)
def kontrola_vstupu_cislo(velikost):
    if not velikost.isdigit():
        return True
    if 2 < int(velikost) < 11 and not int(velikost) == 6:
        return False
    return True


# kontroluje nazev (True = v datech, False = neni v datech)
def kontrola_nazvu(nazev):
    for key in bd.ctverce.keys():
        if key == nazev:
            return True
    return False


# kontrola vstupu 2 velikosti (True = chyba, False = spravne)
def kontrola_vstupu_2cisla(cislo1, cislo2, velikost):
    if not cislo1.isdigit() or not cislo2.isdigit():
        return True
    if int(cislo1) > int(velikost) or int(cislo1) < 1 or int(cislo2) > int(velikost) or int(cislo2) < 1:
        return True
    return False


# prohodi sloupce
def prohod_sloupce(sloupec1, sloupec2, ctverec):
    novy_ctverec = []
    # radek
    for i in range(int(ctverec[0])):
        r = i
        # sloupec
        for j in range(int(ctverec[0])):
            s = j
            # pokud zadany sloupec, pouzij druhy sloupec
            if s == int(sloupec1) - 1:
                s = int(sloupec2) - 1
            # pokud zadany sloupec, pouzij druhy sloupec
            elif s == int(sloupec2) - 1:
                s = int(sloupec1) - 1
            # jedna "dvojice" ctverce
            cast = [ctverec[1][int(ctverec[0]) * r + s][0], ctverec[1][int(ctverec[0]) * r + s][1]]
            # prida "dvojici"
            novy_ctverec.append(cast)
    return novy_ctverec


# prohodi radky
def prohod_radky(radek1, radek2, ctverec):
    novy_ctverec = []
    # radek
    for i in range(int(ctverec[0])):
        r = i
        # pokud zadany radek, pouzij druhy radek
        if r == int(radek1) - 1:
            r = int(radek2) - 1
        # pokud zadany radek, pouzij druhy radek
        elif r == int(radek2) - 1:
            r = int(radek1) - 1
        # sloupec
        for j in range(int(ctverec[0])):
            s = j
            # jedna "dvojice" ctverce
            cast = [ctverec[1][int(ctverec[0]) * r + s][0], ctverec[1][int(ctverec[0]) * r + s][1]]
            # prida "dvojici"
            novy_ctverec.append(cast)
    return novy_ctverec
