"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-12-05
Program: Inferencni modul
Verze: 1.0.0
"""

# komunikacni modul
import komunikacni_modul as km
# baze znalosti
import baze_znalosti as bz
# vysvetlovaci modul
import vysvetlovaci_modul as vm
# baze dat
import baze_dat as bd


# funkce obsluhujici hlavni menu
def spustit():

    # vypise uvod
    km.vypis_uvod()
    # vypise prikazy pro menu
    km.vypis_menu()

    # promena stavu programu (True = pokracuj, False = konec)
    pokracuj = True

    # pobezi dokud uzivatel nezada prikaz pro skonceni
    while pokracuj:
        # vyzada uzivatele o zadani zpravy
        zprava = km.vstup()

        # prikaz pro konec
        if zprava == "k" or zprava == "K":
            pokracuj = False
        # prikaz pro vypsani prikazu
        elif zprava == "":
            # vypise prikazy pro menu
            km.vypis_menu()
        # prikaz pro vypsani nazvu ulozenych ctvercu
        elif zprava == "2":
            # vypise nazvy ulozenych ctvercu
            km.odpoved(vm.ctverce())
        # resi prikazy se dvema parametry
        elif len(zprava.split()) == 2:
            # rozdeli parametry
            casti_zpravy = zprava.split()
            # prikaz pro vytvoreni noveho ctverce
            if casti_zpravy[0] == "1":
                # kontrola druheho parametru
                if bz.kontrola_vstupu_cislo(casti_zpravy[1]):
                    # vypise zpravu o spatnym zadani druheho parametru
                    km.odpoved(vm.spatna_velikost(casti_zpravy[1]))
                    continue
                # vytvori novy ctverec
                ctverec = ["", [casti_zpravy[1], bz.vytvor_ctverec(int(casti_zpravy[1]))]]
                # spusti funkci pro praci se ctvercem
                obsluhuj_ctverec(ctverec)
            # prikaz pro nacteni ulozeneho ctverce
            elif casti_zpravy[0] == "3":
                # kontrola druheho parametru
                if not bz.kontrola_nazvu(casti_zpravy[1]):
                    # vypise zpravu o spatnym zadani druheho parametru
                    km.odpoved(vm.spatny_nazev(casti_zpravy[1]))
                    continue
                # nacte ulozeny ctverec
                ctverec = [casti_zpravy[1], bd.ctverce[casti_zpravy[1]]]
                # spusti funkci pro praci se ctvercem
                obsluhuj_ctverec(ctverec)
            # prikaz pro odstraneni ulozeneho ctverce
            elif casti_zpravy[0] == "4":
                # kontrola druheho parametru
                if not bz.kontrola_nazvu(casti_zpravy[1]):
                    # vypise zpravu o spatnym zadani druheho parametru
                    km.odpoved(vm.spatny_nazev(casti_zpravy[1]))
                    continue
                # odstrani ctverec z baze dat
                del bd.ctverce[casti_zpravy[1]]
                # vypise zpravu o odstraneni ctverce
                km.odpoved(vm.ctverec_odstranen(casti_zpravy[1]))
            # pripad spatneho prikazu
            else:
                # vypise zpravu o spatnym prikazu
                km.spatny_vstup()
        # pripad spatneho prikazu
        else:
            # vypise zpravu o spatnym prikazu
            km.spatny_vstup()
    # vytvori zpravu kterou ulozi
    uloz = vm.vytvor_data()
    # otevre soubor
    baze_dat_py = open("baze_dat.py", "wb")
    # zapise do souboru
    baze_dat_py.write(uloz.encode("utf-8"))
    # zavre soubor
    baze_dat_py.close()
    # vypise konec programu
    km.vypis_konec()


# funkce pro praci se ctvercem
def obsluhuj_ctverec(ctverec):

    # vypise uvod pro praci se ctvercem
    km.vypis_uvod_ctverec()
    # vypise prikazy pro praci se ctvercem
    km.vypis_ctverec()

    # promena stavu programu (True = pokracuj, False = vrat se do menu)
    pokracuj = True

    # pobezi dokud uzivatel nezada prikaz pro vraceni do menu
    while pokracuj:
        # vypise ctverec
        km.odpoved(vm.vytvor_ctverec(ctverec[1]))

        # vyzada uzivatele o zadani zpravy
        zprava = km.vstup()

        # prikaz pro konec
        if zprava == "k" or zprava == "K":
            pokracuj = False
        # prikaz pro vypsani prikazu
        elif zprava == "":
            # vypise prikazy pro praci se ctvercem
            km.vypis_ctverec()
        # prikaz pro vypsani nazvu ctverce
        elif zprava == "1":
            # vypise nazev ctverce
            km.odpoved(vm.nazev(ctverec[0]))
        # prikaz pro vypsani velikosti
        elif zprava == "3":
            # vypise velikost
            km.odpoved(vm.velikost(ctverec[1][0]))
        # prikaz pro ulozeni ctverce
        elif zprava == "6":
            # kontrola nazvu ctverce
            if ctverec[0] == "":
                # vyzada uzivatele o novy nazev
                rozhodnuti = km.vstup_novy_nazev()
                # spatne zadany nazev
                while len(rozhodnuti.split()) > 1:
                    km.spatny_vstup_nazev()
                    rozhodnuti = km.vstup_novy_nazev()
                # rozhodnuti pro ukonceni akce
                if rozhodnuti == "":
                    # vypis o ukonceni akce
                    km.odpoved(vm.akce_ukoncena())
                    continue
                # zmena nazvu ctverce
                ctverec[0] = rozhodnuti
                # vypis zmeny nazvu ctverce
                km.odpoved(vm.zmena_nazvu(ctverec[0]))
            # kontrola jestli uz neni ulozeny ctverec se stejnym nazvem
            if bz.kontrola_nazvu(ctverec[0]):
                rozhodnuti = ""
                # opakuje se dokud uzivatel nezada ano = A nebo ne = N
                while not rozhodnuti.upper() == "A" and not rozhodnuti.upper() == "N":
                    # vyzada uzivatele o odpoved A nebo N
                    rozhodnuti = km.vstup_ulozeni(ctverec[0])
                    # moznost A
                    if rozhodnuti.upper() == "A":
                        # ulozi ctverec
                        bd.ctverce[ctverec[0]] = ctverec[1]
                        # vypise zpravu o ulozeni
                        km.odpoved(vm.ctverec_ulozen(ctverec[0]))
                    # moznost N
                    elif rozhodnuti.upper() == "N":
                        # vypise zpravu o ukonceni akce
                        km.odpoved(vm.akce_ukoncena())
                    # pripad spatneho prikazu
                    else:
                        # vypise uzivateli zpravu o spatne odpovedi na otazku ano/ne
                        km.odpoved(vm.otazka_ano_ne())
            # pripad ulozeni s nazvem, ktery jeste neni v bazi dat
            else:
                # ulozi ctverec
                bd.ctverce[ctverec[0]] = ctverec[1]
                # zprava o ulozeni
                km.odpoved(vm.ctverec_ulozen(ctverec[0]))
        # resi prikazy se dvema parametry
        elif len(zprava.split()) == 2:
            # rozdeli parametry
            casti_zpravy = zprava.split()
            # prikaz pro zmenu nazvu ctverce
            if casti_zpravy[0] == "2":
                # kontrola noveho nazvu
                if casti_zpravy[1] == "":
                    # vypsani zpravy o spatne zadanem nazvu
                    km.odpoved(vm.nazev_nezadan())
                    continue
                # zmeni nazev ctverce
                ctverec[0] = casti_zpravy[1]
                # vypis zmeny nazvu ctverce
                km.odpoved(vm.zmena_nazvu(ctverec[0]))
            # pripad spatneho prikazu
            else:
                # vypise zpravu o spatnym prikazu
                km.spatny_vstup()
        # resi prikazy se tremi parametry
        elif len(zprava.split()) == 3:
            # rozdeli parametry
            casti_zpravy = zprava.split()
            # prikaz pro prohozeni sloupcu
            if casti_zpravy[0] == "4":
                # kontrolo parametru
                if bz.kontrola_vstupu_2cisla(casti_zpravy[1], casti_zpravy[2], ctverec[1][0]):
                    # vypise zpravu o spatnem zadani parametru
                    km.odpoved(vm.spatna_velikost_ctverec(ctverec[1][0]))
                    continue
                # prohodi sloupce
                ctverec[1][1] = bz.prohod_sloupce(casti_zpravy[1], casti_zpravy[2], ctverec[1])
                # vypise zpravu o prohozeni sloupcu
                km.odpoved(vm.sloupce_prohozeny(casti_zpravy[1], casti_zpravy[2]))
            # prikaz pro prohozeni radku
            elif casti_zpravy[0] == "5":
                # kontrolo parametru
                if bz.kontrola_vstupu_2cisla(casti_zpravy[1], casti_zpravy[2], ctverec[1][0]):
                    # vypise zpravu o spatnem zadani parametru
                    km.odpoved(vm.spatna_velikost_ctverec(ctverec[1][0]))
                    continue
                # prohodi radky
                ctverec[1][1] = bz.prohod_radky(casti_zpravy[1], casti_zpravy[2], ctverec[1])
                # vypise zpravu o prohozeni radku
                km.odpoved(vm.radky_prohozeny(casti_zpravy[1], casti_zpravy[2]))
            # pripad spatneho prikazu
            else:
                # vypise zpravu o spatne zadany nazvu
                if casti_zpravy[0] == "2":
                    km.spatny_vstup_nazev()
                # vypise zpravu o spatnym prikazu
                else:
                    km.spatny_vstup()
        # pripad spatneho prikazu
        else:
            # vypise zpravu o spatne zadany nazvu
            if zprava.split()[0] == "2":
                km.spatny_vstup_nazev()
            # vypise zpravu o spatnym prikazu
            else:
                km.spatny_vstup()

    # vypise uvod do menu
    km.vypis_uvod()
    # vypise prikazy pro menu
    km.vypis_menu()
