"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-12-05
Program: Inferencni modul
Verze: 1.0.0
"""

# baze dat
import baze_dat as bd


# pripravy zpravu o nazvech ulozenych ctvercu
def ctverce():
    # zadny ctverec v datech
    if len(bd.ctverce) == 0:
        return "V datech žádné čtverce nejsou\n"
    odpoved = "Názvy čtverců:\n"
    # prochazi data a pridava nazvy ctvercu do odpovedi
    for key in bd.ctverce.keys():
        odpoved += key + "\n"
    return odpoved


# pripravy zpravu o odstraneni ctverce
def ctverec_odstranen(nazev):
    odpoved = "Čtverec s názvem \"" + nazev + "\" byl odstraněn"
    return odpoved


# pripravy zpravu o spatne zadane velikosti
def spatna_velikost(velikost):
    odpoved = "Číslo \"" + velikost + "\" bylo zadáno ve špatném formátu, je rovno 6, " \
                                      "je příliš malé nebo je příliš velké. " \
                                      "Nejmenší velikost pro čtverce je 3 a největší velikost je 10."
    return odpoved


# pripravy zpravu o spatne zadanym nazvu
def spatny_nazev(nazev):
    odpoved = "Čtverec s názvem \"" + nazev + "\" neexistuje"
    return odpoved


# pripravy ctverec na vypsani
def vytvor_ctverec(ctverec):
    odpoved = "Čtverec:\n"
    # radky
    for i in range(int(ctverec[0])):
        # sloupce
        for j in range(int(ctverec[0])):
            # jedna "dvojice" ctverce
            cast = "[" + ctverec[1][int(ctverec[0]) * i + j][0] + ", " + ctverec[1][int(ctverec[0]) * i + j][1] + "]"
            # velikost < 10
            if int(ctverec[0]) < 10:
                odpoved += " " + cast
            # resi spravne jiny pocet znaku pro velikost < 100
            else:
                if len(cast) == 6:
                    odpoved += "  " + cast + " "
                elif len(cast) == 7:
                    odpoved += " " + cast + " "
                else:
                    odpoved += " " + cast
        odpoved += "\n"
    return odpoved


# pripravy zpravu o nazvu ctverce
def nazev(nazev):
    if nazev == "":
        odpoved = "Čtverec nemá název\n"
    else:
        odpoved = "Název čtverce: " + nazev + "\n"
    return odpoved


# pripravy odpoved o velikosti ctverce
def velikost(velikost):
    odpoved = "Velikost čtverce: " + velikost + "x" + velikost + "\n"
    return odpoved


# pripravy zpravu o zmene nazvu ctverce
def zmena_nazvu(nazev):
    odpoved = "Nový název čtverce: " + nazev + "\n"
    return odpoved


# pripravy zpravu o ulozeni ctverce
def ctverec_ulozen(nazev):
    odpoved = "Čtverec uložen pod názvem: " + nazev + "\n"
    return odpoved


# vytvori nove data pro zapsani do "baze_dat.py"
def vytvor_data():
    uloz = "\"\"\"\nAutor: Matěj Vohradský (vohry8@students.zcu.cz)\nDatum: 2023-12-05\nProgram: Baze dat\n" \
           "Verze: 1.0.0\n\"\"\"\n\n# zadane reseni pro sude ctverce\nsude = {"
    for key, value in bd.sude.items():
        uloz += "\n\"" + key + "\": [\"" + value[0] + "\", ["
        for i in range(int(value[0]) * int(value[0])):
            uloz += "[\"" + value[1][i][0] + "\", \"" + value[1][i][1] + "\"], "
        uloz = uloz.removesuffix(", ") + "]],"
    uloz = uloz.removesuffix(",") + "\n}\n\n"
    uloz += "# Struktura pro uchovani dat ve tvaru: nazev: [velikost, [ctverec]]\nctverce = {"
    # projde ulozene ctverce a pripravi je na zapis
    for key, value in bd.ctverce.items():
        uloz += "\n\"" + key + "\": [\"" + value[0] + "\", ["
        for i in range(int(value[0]) * int(value[0])):
            uloz += "[\"" + value[1][i][0] + "\", \"" + value[1][i][1] + "\"], "
        uloz = uloz.removesuffix(", ") + "]],"
    uloz = uloz.removesuffix(",") + "\n}\n"
    return uloz


# pripravy zpravu o ukonceni akce
def akce_ukoncena():
    odpoved = "Akce byla ukončena\n"
    return odpoved


# pripravy zpravu o spatne odpovedi na otazku ano/ne
def otazka_ano_ne():
    odpoved = "Na tuto otázku odpovězte buď ano = \"A\" nebo ne = \"N\""
    return odpoved


# pripravy zpravu o spatne zadanem nazvu
def nazev_nezadan():
    odpoved = "Nebyl zadán nový název čtverce\n"
    return odpoved


# pripravy zpravu o prohozenych sloupců
def sloupce_prohozeny(sloupec1, sloupec2):
    odpoved = "Sloupce " + sloupec1 + " a " + sloupec2 + " byly prohozeny\n"
    return odpoved


# pripravy zpravu o prohozenych radcich
def radky_prohozeny(radek1, radek2):
    odpoved = "Řádky " + radek1 + " a " + radek2 + " byly prohozeny\n"
    return odpoved


# pripravy zpravu o spatne zadane velikosti ctverce
def spatna_velikost_ctverec(velikost):
    odpoved = "Čísla byla zadána ve špatném formátu nebo nebyla v intervalu od 1 do " + velikost + "\n"
    return odpoved
